
//compatibile con il protocollo flauto central v 1.5
const VERSION ="00.00.15";

const SYSEX_START = 0xf0;
const SYSEX_STOP = 0xf7;

/*const AchesSenderADDR = {
    NULL        :0x00,
    ARCHES      :0x01,
    PC          :0x02,
};*/

const MultiBLEADDR={
  SYSEX_H1          : 0x00,
  SYSEX_H2          : 0x2F, 
  SYSEX_H3          : 0x7F,
  SYSEX_H4_Fid      : 0x00,   //0 is re.corder Family
  SYSEX_H5_Pid_ReC  : 0x01,    //0 is re.corder
  SYSEX_H5_Pid_MR   : 0x02    //2 is multiRec usb dongle
}

const SyseExCMD = {
    ACK         :0x01,
    NACK        :0x02,
    //da ripulire
    IDENTITY    :0x10,
    FILE_LIST   :0x20,
    DELETE_FILE :0x21,
    RENAME_FILE :0x22,  
    GET_FILE    :0x23,
    WRITE_FILE  :0x24,
    SET_PATTERN :0x25,
    //comandi multiBle
    SYSEX_CMD_STATUS                      : 0x18,
    SYSEX_CMD_ENCAPSULATION               : 0x50, //0x50
    SYSEX_CMD_START_SCAN                  : 0x51, //0x51
    SYSEX_CMD_STOP_SCAN                   : 0x52, //0x52
    SYSEX_CMD_NOTIFY_Client               : 0x53, //0x53
    SYSEX_CMD_NOTIFY_Client_connected     : 0x54, //0x54
    SYSEX_CMD_NOTIFY_Client_disconnection : 0x55, //0x55
    SYSEX_CMD_Connect_specific_Client     : 0x56, //0x56
    SYSEX_CMD_GET_Client_connected_list   : 0x57, //0x57
    SYSEX_CMD_Disconnect_specific_Client  : 0x58, //0x58
    SYSEX_CMD_Disconnect_all_Client       : 0x59, //0x59
    SYSEX_CMD_System_Reboot               : 0x60, //0x60
    SYSEX_CMD_System_Info                 : 0x61, //0x61
    SYSEX_CMD_GET_scan_list               : 0x62, //0x62
    SYSEX_CMD_Auto_Connenct               : 0x63,
    SYSEX_CMD_NOTIFY_Auto_Connenct        : 0x64,
    SYSEX_CMD_NOTIFY_Clien_scan_list      : 0x65,
    SYSEX_CMD_Debug                       : 0x7F, //usato per debug, nel payload i byte  indicano il passaggio in dati punti del codice o codici di errore a seconda dei casi
  
  };

const ScanListType = {
  Retrive_only_list :0,
  Scan_once         :1,
  Scan_continually  :2,
  };

  const AutoConnType = {
    disable                   :0,
    active_and_save_current   :1,
    };
//statis bit position
const StatusBit={
  STATUS_BIT_SCAN            :0,//b0
  STATUS_BIT_SCAN_LOOP       :1,//b1
  STATUS_BIT_SCAN_LIST_REQ   :2,//b2 requested to make scan list
  STATUS_BIT_AUTO_SCAN       :3,//b3
};
//NACK error list
const NRF_ERROR_RESOURCES = 19;
const SysexNackErr = {
  SYSEX_CMD_NACK_ERR_CMD          :0,
  SYSEX_CMD_NACK_ERR_BAD_FORMAT   :1,
  SYSEX_CMD_NACK_ERR_LOCK         :2,
  SYSEX_CMD_NACK_ERR_PARAM        :3,
  SYSEX_CMD_NACK_ERR_TIMEOUT      :4,
  SYSEX_CMD_NACK_ERR_STORAGE_ERROR:5,
  SYSEX_CMD_NACK_ERR_ABORT        :6,
  SYSEX_CMD_NACK_ERR_BUSY         :7,    //già codificati nel flauto
  SYSEX_CMD_NACK_ERR_NUM          :8,    //8
  
SYSEX_CMD_NACK_ERR_MAX_CONNECTIONS_REACHED      : NRF_ERROR_RESOURCES+8,
SYSEX_CMD_NACK_ERR_IN_SCANNING_AND_SCAN_STOPPED : NRF_ERROR_RESOURCES+9,//indica che era in scan e che lo scan ora è stoppato

};

//other errors



const CMD_SEND_POSITION = 6;
const CMD_RECEIVED_POSITION = 7;  //command eco
const SYSEX_POS_Data_rp = CMD_RECEIVED_POSITION + 1;
/*
class jsonClass {
  constructor(name, data) {
    this.name = name;
    this.data = data;
  }
}*/

const MAC_LENGTH = 6;

//var jsonFile = new jsonClass(null,null);

var access; //contiene l'istanza dell'oggetto midi
var lastCMDsend = 0x00; //contiene l'ultimo comando midi inviato
var lastMSGsend = []; //contiene l'ultimo msg midi inviato, utile se deve essere reiterato
//var jsonRequested = ""; //contiene il nome patter richiesto al arches
var firstScan = true  //usata per indicare la prima scansione


//inizializzo midi e dati
document.addEventListener("DOMContentLoaded",function(){midiInit(chooser("rx"), chooser("tx"), DataReceiver);Loader()});
//label versione corrente
const response = document.getElementById("fwLabel");
response.innerHTML = "Ver. "+VERSION;

//lettura lista pattern e start animazione
const  readPatList = document.getElementById("scanBLE");
readPatList.addEventListener("click", function(){
  if(firstScan==true)
  {
    /*MakeMsg(SyseExCMD.SYSEX_CMD_Disconnect_all_Client); //disconnetto tutti i connessi*/
    MakeMsg(SyseExCMD.SYSEX_CMD_STATUS); //chiedo lo stato del dispositivo (mi interessa lo stao dell'autocconect in flash)
    MakeMsg(SyseExCMD.SYSEX_CMD_GET_Client_connected_list); //richiedo la lista dei connessi
    firstScan = false;
  }
  
  

  MakeMsg([SyseExCMD.SYSEX_CMD_GET_scan_list,ScanListType.Scan_once]);
  ScanAnimationStart()
});

//salvo la configurazione corrente (device connessi e attivo l'autonnessione)
/*const  autoConnCmd = document.getElementById("autoConnBt");
autoConnCmd.addEventListener("click", function(){

  MakeMsg([SyseExCMD.SYSEX_CMD_Auto_Connenct,AutoConnType.active_and_save_current]);

});*/

//in base al check box attivo o disattivo il pulsante per il salvataggio della lista dei device connessi al momento
const  autoConnCBox = document.getElementById("autoConnCbox");
autoConnCBox.addEventListener("change", function(){


  if(autoConnCBox.checked == true)
  { 
    //ListDeleteAllChildRaws("deviceTables","tfoot");
    //ListDeleteAllChildRaws("deviceTables","tbody");
    MakeMsg([SyseExCMD.SYSEX_CMD_Auto_Connenct,AutoConnType.active_and_save_current]);
    //MakeMsg(SyseExCMD.SYSEX_CMD_START_SCAN);
    document.getElementById("scanLoop").checked = false;    //elimino il loop dello scan se attivo
    document.getElementById("autoconnectState").style.visibility ="visible" ;
    
  }
  else
  { //disattivo la funzione
    MakeMsg([SyseExCMD.SYSEX_CMD_Auto_Connenct,AutoConnType.disable]);
    //MakeMsg(SyseExCMD.SYSEX_CMD_STOP_SCAN);
    document.getElementById("autoconnectState").style.visibility = "hidden" ;  //nascondo lable dei msg di autoconnessione
  }

  MakeMsg(SyseExCMD.SYSEX_CMD_STATUS); //chiedo lo stato del dispositivo (mi interessa lo stao dell'autocconect in flash)

});



/*
const string_to_char_code = ([...string]) => 
{
  const array = string.map((char) => {
    return char.charCodeAt(0);
  });
  // array of unicode
  return array;
}
*/

//formatta il msg da inviare
function MakeMsg(data)
{ 
    //alert("Ciao");  
    //const message = [0xf0, 0x02, 0x23, 0x70, 0x61, 0x74, 0x30, 0x30, 0x31, 0x2E, 0x61, 0x6A, 0x73, 0x00, 0xf7];
    lastMSGsend = data;  //salvo messaggio parziale manca intestazione
    let message = [SYSEX_START, MultiBLEADDR.SYSEX_H1, MultiBLEADDR.SYSEX_H2, MultiBLEADDR.SYSEX_H3, MultiBLEADDR.SYSEX_H4_Fid, MultiBLEADDR.SYSEX_H5_Pid_MR];
    message = message.concat(data);
    message.push(SYSEX_STOP);
    const  midiSelectOut = document.getElementById("tx");
    return sendMidi(access,midiSelectOut.value,message);
}


async function midiInit(rxchooser, txchooser, receive) 
{
    let input, output;

    //console.log("midi function");

    try {
      access = await navigator.requestMIDIAccess({sysex: true});
    } catch {
      return null;
    }

    rxchooser = rxchooser(function(id) {
      if (input && input.id != id && receive)
      {
        //console.log("remove");
        input.removeEventListener("midimessage", receive);
      }
      input = access.inputs.get(id);
      if (input && receive)
      {
        //console.log("add");
        input.addEventListener("midimessage", receive);
      }
    });

    txchooser = txchooser(function(id) {
      output = access.outputs.get(id);
    });

    access.addEventListener("statechange", function(event) {
      const id = event.port.id, state = event.port.state;
      const name = state == "connected" ? event.port.name : null;
      if (event.port.type == "input")
        rxchooser(id, name);
      else if (event.port.type == "output")
        txchooser(id, name);
    });

    access.inputs.forEach(port => rxchooser(port.id, port.name));
    access.outputs.forEach(port => txchooser(port.id, port.name));
    return data => output && output.send(data);
}

//carica dati all'inizio
function Loader()
{

}


//crea casella di selezione
function chooser(select) 
{
    select = document.getElementById(select);
    return function(choose) 
    {
        select.onchange = event => choose(select.value);
        return function(id, name) 
        {
            for (let option = 0; option < select.length; option++)
            if (select.options[option].value == id) 
            {
                if (name) {
                if (select.options[option].text != name)
                    select.options[option].text = name;
                return;
                }
                select.options[option].remove(option);
            }
            if (name) 
            {
            const option = document.createElement("option");
            option.value = id;
            option.text = name;
            select.add(option);
            }
            choose(select.value);
            //appena carico la porta midi di trasmissione chiedo lo stao del dispositivo (sperando che la porta sia quella giusta)
            if(select.id == "tx" && select.options.length)
            {
              MakeMsg(SyseExCMD.SYSEX_CMD_STATUS);
              ListDeleteAllChildRaws("deviceTables","tfoot");
              ListDeleteAllChildRaws("deviceTables","tbody");
              console.log("---- pulisco ---")
              MakeMsg(SyseExCMD.SYSEX_CMD_GET_Client_connected_list); //richiedo la lista dei connessi
              
            }
        };
        
    };

    
}
var timerNotices;

//ricevo i dati sysex del midi
function DataReceiver(event) 
{
    let strJson;

    //printo la risposta
    console.log("COMANDO ricevuto:");
    console.log(toHexString(event.data," "));
    console.log("Lunghezza: ",event.data.length);
    
    //controllo che sia un sysex
    if(event.data[0] == SYSEX_START)
    {
      const response = document.getElementById("labelResp");
      if(event.data[CMD_SEND_POSITION] != SyseExCMD.NACK)
      {//ack
        response.innerHTML = "OK";
        response.style.color = "#04f634";
        setTimeout(function () {
          response.style.color = "#167231";
        },5000);

        if(event.data[CMD_SEND_POSITION] == SyseExCMD.ACK)  //risposte
        {
          switch(event.data[CMD_RECEIVED_POSITION])  
          {
              //comando non gestito completamente
              case SyseExCMD.SYSEX_CMD_GET_Client_connected_list: //arriva la lista dei device in scan
              {
                let devicesNum = event.data[SYSEX_POS_Data_rp];
                let dataDecode = [];
                let handler,name,mac,macFlags;

                SysexDataDecode(event.data,SYSEX_POS_Data_rp+1,dataDecode);

                //delete old rows
                //ListDeleteAllChildRaws("deviceTables","tfoot");
               // console.log("pulisco ---")


                y=0;
                for(i = 0;i<devicesNum;i++)
                {
                  let index = -1;

                  console.log("y : ",y)
                  console.log(dataDecode);

                  handler = BytesToUint16(dataDecode[y],dataDecode[y+1]);
                  y=y+2;
                  console.log(handler)

                  name = String.fromCharCode.apply(null,dataDecode.slice(y+1,y+dataDecode[y]+1)); //estraggo il nome
                  y = y+dataDecode[y]+1;
                  console.log(name)
                  macFlags = dataDecode.slice(y,y+1); //flag del mac, per certi dispositivi è necessario ad esempio se vogliono in bonding
                  macFlags = toHexString(macFlags,':')
                  mac = dataDecode.slice(y+1,y+1+MAC_LENGTH); //estraggo il mac, il primo byte contiene flags
                  y = y+1+MAC_LENGTH;
                  console.log("mac orig ",mac)
                  mac = mac.reverse();
                  mac = toHexString(mac,':');  //in striga con :
                  console.log(mac)

                  index = ListFindeElement("deviceTables","tbody",1,mac);
                  if(index <0)  //se non in lista lo metto
                    ListaAddRaw("deviceTables","tbody",handler,name,mac,undefined,macFlags); //aggiungo device alla lista dei connessi

                }



              }
              break;
              case SyseExCMD.SYSEX_CMD_GET_scan_list: //arriva la lista dei device in scan
              {
                let devicesNum = event.data[SYSEX_POS_Data_rp];
                let indexLast = event.data.indexOf(SYSEX_STOP);
                let dataDecode = [];
                let name,mac,rssi,i,y,macFlags;
                let indexsList = new Array(ListGetLen("deviceTables","tfoot")).fill(false);//arrai che fa da lista per la cancellazione dei dispositivi non + presenti

                console.log("lunghezza msg: %d",indexLast-SYSEX_POS_Data_rp);
                SysexDataDecode(event.data,SYSEX_POS_Data_rp+1,dataDecode);

                //delete old rows
                //ListDeleteAllChildRaws("deviceTables","tfoot");
                y=0;
                for(i = 0;i<devicesNum;i++)
                {
                  let index = -1;

                  console.log("y : ",y)
                  console.log(dataDecode);
                  name = String.fromCharCode.apply(null,dataDecode.slice(y+1,y+dataDecode[y]+1)); //estraggo il nome
                  y = y+dataDecode[y]+1;
                  console.log(name)

                  macFlags = dataDecode.slice(y,y+1); //flag del mac, per certi dispositivi è necessario ad esempio se vogliono in bonding
                  macFlags = toHexString(macFlags,':')
                  mac = dataDecode.slice(y+1,y+1+MAC_LENGTH); //estraggo il mac, il primo byte contiene flags
                  y = y+1+MAC_LENGTH;
                  console.log("mac orig ",mac)
                  mac = mac.reverse();
                  mac = toHexString(mac,':');  //in striga con :
                  console.log(mac)

                  rssi = Int8(dataDecode.slice(y,y+1));
                  y=y+1;
                  console.log(rssi)
                  index = ListFindeElement("deviceTables","tfoot",1,mac);
                  if(index <0)
                  {//add to table
                    ListaAddRaw("deviceTables","tfoot",-1,name,mac,rssi,macFlags);
                    indexsList[ListGetLen("deviceTables","tfoot")-1] = true;
                    
                  }
                  else  //già in lista
                  {
                    indexsList[index] = true;
                    //aggiornare solo ssi o anche tutti i campi
                    ListaUpdateRaw("deviceTables","tfoot",index,2,rssi);
                  }

                }
                /*
                ListDeleteChildsRaw("deviceTables","tfoot",indexsList);  //indico quali righe eliminare
                
                if(document.getElementById("scanLoop").checked) //controllo se lo scan va fatto in contnuazione
                {
                  //rescan e ripopolo la lista
                  MakeMsg([SyseExCMD.SYSEX_CMD_GET_scan_list,ScanListType.Scan_once])
                }
                
                ScanAnimationStop();

                if(devicesNum == 0)
                {
                  console.log("No devices found");
                  const notices = document.getElementById("labelNotices");
                  notices.innerHTML = "NO devices found";
                  notices.style.visibility = "visible";

                  if(timerNotices)  //se c'è già un listanza la cancello
                    clearTimeout(timerNotices);
                  timerNotices = setTimeout(function() 
                  {
                      clearTimeout(timerNotices);
                      console.log("Time Notice is up! ",timerNotices);
                      document.getElementById("labelNotices").style.visibility= "hidden" ;
                  }, 3000);

                }
                */
              }
              break;
              case SyseExCMD.SYSEX_CMD_STATUS:
                {
                  console.log("SYSEX_CMD_STATUS")
                  console.log(event.data);
                  console.log(event.data.length);

                  if((event.data[SYSEX_POS_Data_rp+1] >>StatusBit.STATUS_BIT_AUTO_SCAN) ==1)  //autoconec attiva
                  {
                    autoConnCBox.checked = true;
                    document.getElementById("scanLoop").checked = false;    //elimino il loop dello scan se attivo
                    document.getElementById("scanLoop").disabled = true;    //disabilito la possibilità di richiedere il loop
                    document.getElementById("scanBLE").disabled = true;    //disabilito la possibilità di richiedere lo scan
                  }
                  else
                  {
                    autoConnCBox.checked = false;
                    document.getElementById("scanLoop").disabled = false;    //abilito la possibilità di richiedere il loop
                    document.getElementById("scanBLE").disabled = false ;    //abilito la possibilità di richiedere lo scan
                  }
                }
                break;
              case SyseExCMD.SYSEX_CMD_System_Info:
              {
                let dataDecode = [];
                console.log(event.data);
                console.log(event.data.length);
                SysexDataDecode(event.data,SYSEX_POS_Data_rp,dataDecode);
                console.log(toHexString(dataDecode," "));
                if(dataDecode[9] > 0)  //autoconec attiva
                {
                  autoConnCBox.checked = true;
                }


              }
              break;
          }
        }
        else  // messaggi spontanei
          switch(event.data[CMD_SEND_POSITION])  
          {
              case SyseExCMD.SYSEX_CMD_NOTIFY_Clien_scan_list: //arriva la lista dei device in scan
              {
                let devicesNum = event.data[CMD_RECEIVED_POSITION];
                let indexLast = event.data.indexOf(SYSEX_STOP);
                let dataDecode = [];
                let name,mac,rssi,i,y,macFlags;
                let indexsList = new Array(ListGetLen("deviceTables","tfoot")).fill(false);//arrai che fa da lista per la cancellazione dei dispositivi non + presenti

                console.log("lunghezza msg: %d",indexLast-CMD_RECEIVED_POSITION);
                SysexDataDecode(event.data,CMD_RECEIVED_POSITION+1,dataDecode);

                //delete old rows
                //ListDeleteAllChildRaws("deviceTables","tfoot");
                y=0;
                for(i = 0;i<devicesNum;i++)
                {
                  let index = -1;

                  console.log("y : ",y)
                  console.log(dataDecode);
                  name = String.fromCharCode.apply(null,dataDecode.slice(y+1,y+dataDecode[y]+1)); //estraggo il nome
                  y = y+dataDecode[y]+1;
                  console.log(name)
                  macFlags = dataDecode.slice(y,y+1); //flag del mac, per certi dispositivi è necessario ad esempio se vogliono in bonding
                  macFlags = toHexString(macFlags,':')
                  mac = dataDecode.slice(y+1,y+1+MAC_LENGTH); //estraggo il mac, il primo byte contiene flags
                  y = y+1+MAC_LENGTH;
                  console.log("mac orig ",mac)
                  mac = mac.reverse();
                  mac = toHexString(mac,':');  //in striga con :
                  console.log(mac)

                  rssi = Int8(dataDecode.slice(y,y+1));
                  y=y+1;
                  console.log(rssi)
                  index = ListFindeElement("deviceTables","tfoot",1,mac);
                  if(index <0)
                  {//add to table
                    ListaAddRaw("deviceTables","tfoot",-1,name,mac,rssi,macFlags);
                    indexsList[ListGetLen("deviceTables","tfoot")-1] = true;
                    
                  }
                  else  //già in lista
                  {
                    indexsList[index] = true;
                    //aggiornare solo ssi o anche tutti i campi
                    ListaUpdateRaw("deviceTables","tfoot",index,2,rssi);
                  }

                }
                ListDeleteChildsRaw("deviceTables","tfoot",indexsList);  //indico quali righe eliminare

                if(document.getElementById("scanLoop").checked) //controllo se lo scan va fatto in contnuazione
                {
                  //rescan e ripopolo la lista
                  MakeMsg([SyseExCMD.SYSEX_CMD_GET_scan_list,ScanListType.Scan_once])
                }

                ScanAnimationStop();

                if(devicesNum == 0)
                {
                  console.log("No devices found");
                  const notices = document.getElementById("labelNotices");
                  notices.innerHTML = "NO devices found";
                  notices.style.visibility = "visible";

                  if(timerNotices)  //se c'è già un listanza la cancello
                    clearTimeout(timerNotices);
                  timerNotices = setTimeout(function() 
                  {
                      clearTimeout(timerNotices);
                      console.log("Time Notice is up! ",timerNotices);
                      document.getElementById("labelNotices").style.visibility= "hidden" ;
                  }, 3000);

                }
              }
              break;


            case SyseExCMD.SYSEX_CMD_NOTIFY_Client:    //notifica device trovato
            {
              /* dovrebbeessere così ma non è implementabile in modo corretto perchè nel dongle ho ho uuid o il nome, in questa applicazione servono entrambe
              //let devicesNum = event.data[SYSEX_POS_Data_rp];
                let indexLast = event.data.indexOf(SYSEX_STOP);
                let dataDecode = [];
                let name,mac,rssi,i,y;
                //let indexsList = new Array(ListGetLen("deviceTables","tfoot")).fill(false);//arrai che fa da lista per la cancellazione dei dispositivi non + presenti

                console.log("lunghezza msg: %d",indexLast-SYSEX_POS_Data_rp);
                SysexDataDecode(event.data,SYSEX_POS_Data_rp,dataDecode);

                //delete old rows
                //ListDeleteAllChildRaws("deviceTables","tfoot");
                y=0;
                //for(i = 0;i<devicesNum;i++)
                {
                  let index = -1;

                  console.log("y : ",y)
                  console.log(dataDecode);
                  name = String.fromCharCode.apply(null,dataDecode.slice(y,y+dataDecode[y])); //estraggo il nome
                  y = y+dataDecode[y];
                  console.log(name)

                  mac = dataDecode.slice(y,y+MAC_LENGTH); //estraggo il mac, il primo byte è sempre un byte di flag a 0 (lo tolgo)
                  y = y+MAC_LENGTH;
                  console.log("mac orig ",mac)
                  mac = mac.reverse();
                  mac = toHexString(mac,':');  //in striga con :
                  console.log(mac)

                  rssi = Int8(dataDecode.slice(y,y+1));
                  y=y;
                  console.log(rssi)
                  index = ListFindeElement("deviceTables","tfoot",1,mac);
                  if(index <0)
                  {//add to table
                    ListaAddRaw("deviceTables","tfoot",-1,name,mac,rssi);
                    //indexsList[ListGetLen("deviceTables","tfoot")-1] = true;
                    
                  }
                  else  //già in lista
                  {
                    //indexsList[index] = true;
                    //aggiornare solo ssi o anche tutti i campi
                    ListaUpdateRaw("deviceTables","tfoot",index,2,rssi);
                  }

                }
              */
            }
            break;
            case SyseExCMD.SYSEX_CMD_NOTIFY_Client_connected:    //notifica device connesso
            {
              let dataDecode = [];
              let handler,name,nameLen,mac,rssi,macFlags;
              SysexDataDecode(event.data,CMD_RECEIVED_POSITION,dataDecode);
              //console.log("dataDecode ",dataDecode)
              handler = BytesToUint16(dataDecode[0],dataDecode[1]);

              nameLen = dataDecode[2];
              name = String.fromCharCode.apply(null,dataDecode.slice(3,nameLen+3)); //estraggo il nome
              console.log(name)

              macFlags = dataDecode.slice(y,y+1); //flag del mac, per certi dispositivi è necessario ad esempio se vogliono in bonding
              macFlags = toHexString(macFlags,':')
              mac = dataDecode.slice(3+1+nameLen,3+1+nameLen+MAC_LENGTH); //estraggo il mac, il primo byte contiene flags
              console.log("mac ",mac)
              mac = mac.reverse();
              mac = toHexString(mac,':');  //in striga con :
              console.log(mac)
              //cercare il mac nella lista

              ListaAddRaw("deviceTables","tbody",handler,name,mac,rssi,macFlags); //aggiungo device alla lista connessi
              DeleteDeviceInList("deviceTables","tfoot",mac);  //lo elimino da quella degli scan

              //rescan e ripopolo la lista
              if(autoConnCBox.checked == false)
                MakeMsg([SyseExCMD.SYSEX_CMD_GET_scan_list,ScanListType.Scan_once])

            }
            break;
            case SyseExCMD.SYSEX_CMD_NOTIFY_Client_disconnection:    //device disconnesso
            {
              //elimino le righe in tabella
              let dataDecode = [];
              let handler,name,reason,mac;
              SysexDataDecode(event.data,CMD_RECEIVED_POSITION,dataDecode);
              //console.log("dataDecode ",dataDecode)
              handler = BytesToUint16(dataDecode[0],dataDecode[1]);

              reason = dataDecode[2];

              mac = dataDecode.slice(3+1,3+1+MAC_LENGTH); //estraggo il mac, il primo byte è sempre un byte di flag a 0 (lo tolgo)
              console.log("mac ",mac)
              mac = mac.reverse();
              mac = toHexString(mac,':');  //in striga con :
              console.log(mac)

              DeleteDeviceInList("deviceTables","tbody",mac);

              //if(lastCMDsend == SyseExCMD.SYSEX_CMD_Connect_specific_Client)  //connessione fallita ad un device, rescan
                //rescan e ripopolo la lista
              if(autoConnCBox.checked == false)
                MakeMsg([SyseExCMD.SYSEX_CMD_GET_scan_list,ScanListType.Scan_once])
              
            }
            break;

            case SyseExCMD.SYSEX_CMD_NOTIFY_Auto_Connenct:
            {
              let dataDecode = [];
              let state,msg;
              //SysexDataDecode(event.data,CMD_RECEIVED_POSITION,dataDecode);
              //console.log("dataDecode ",dataDecode)
              state = event.data[CMD_RECEIVED_POSITION] ;
              console.log("state", state);

              if(state != 0)
                msg = "In progress";
              else
              {
                msg = "Expired";
                document.getElementById("scanLoop").disabled = false;   //abilito la possibilità di richiedere il loop
                document.getElementById("scanBLE").disabled = false;    //abilito la possibilità di richiedere lo scan
              }
                document.getElementById("autoconnectState").style.visibility ="visible" ;
                document.getElementById("autoconnectState").innerHTML = msg; 

            }
            break;
          }


      }
      else  //nack
      {
        //console.log("NACK")
        switch(event.data[CMD_RECEIVED_POSITION])  
          {
              case SyseExCMD.SYSEX_CMD_Connect_specific_Client: //tentata connessione quando non dovevo
                {
                  let reason = event.data[SYSEX_POS_Data_rp];
                  //console.log("NACK SCAN ",reason,SysexNackErr.SYSEX_CMD_NACK_ERR_IN_SCANNING_AND_SCAN_STOPPED)
                  //reinvio il messaggio se è tutto corretto
                  if(reason == SysexNackErr.SYSEX_CMD_NACK_ERR_IN_SCANNING_AND_SCAN_STOPPED && lastMSGsend[0]==SyseExCMD.SYSEX_CMD_Connect_specific_Client)
                  {
                    MakeMsg(lastMSGsend);
                    console.log("-->reinvio msg ")
                  }


                }
              break;
          }


        response.innerHTML = "KO";
        response.style.color = "#fa805e";
        setTimeout(function () {
          response.style.color = "#610c0f";
      },5000);
      }
    }
}

function sendMidi(midiAccess, portID,msg) 
{
    console.log("Uscita midi : " + midiAccess);
    console.log("messaggio da inviare");
    console.log(toHexString(msg," "))
    //console.log(msg.reduce(function(s, x) {return s + " " + x.toString(16).padStart(2, "0");}));
    //const noteOnMessage = [0xf0, 0x02, 0x10, 0x00, 0xf7 ]; // note on middle C, full velocity
    //const noteOnMessage = [0xf0, 0x02, 0x23, 0x70, 0x61, 0x74, 0x30, 0x30, 0x31, 0x2E, 0x61, 0x6A, 0x73, 0x00, 0xf7];
    lastCMDsend = msg[CMD_SEND_POSITION];   //salvo cmd inviato
    const output = midiAccess.outputs.get(portID);
    console.log("midi output : "+output);
    if(output !== undefined)
    {
      output.send(msg); //omitting the timestamp means send immediately.
      return true;
    }
    else
    {
      console.log("midi Tx non definita");
      return false;
    }
    //output.send([0x80, 60, 0x40], window.performance.now() + 1000.0); // timestamp = now + 1000ms.
    
}  


//remove all Child in a node
function RemoveAllChild(parent)
{
  while(parent.childNodes.length>0 )
  {
    //console.log(i);
    parent.removeChild(parent.childNodes[0]);
  }
}

//decodifica da 2 byte torna a 1
function SysexDataDecode(DataIn,DataInIndex,DataOut/*,dataOutLen*/)
{
  let i,y;
  //SendMidi(0x90, (uint8_t) (dataInLen),(uint8_t) dataOutLen & 0x0f,1);  //debug
  
  /*if(dataOutLen<(dataInLen/2))
    return 0;*/
  y = 0;
  for(i = DataInIndex;i < DataIn.length;i=i+2)
  {
    DataOut[y++] = (((DataIn[i] & 0x0F) << 4) | (DataIn[i+1] & 0x0F));
  }
  return y;

}
//codifica da 1 byte splitta in 2 byte i rispettivi nibble
function SysexDataCode(DataIn,DataOut)
{
  let i,y;

  /*if(dataOutLen<(dataInLen*2))
    return 0;*/

  y = 0;
  for(i = 0;i < DataIn.length ;i++)
  {
    console.log((DataIn[i] & 0xF0));
    DataOut[y++] = ((DataIn[i] & 0xF0) >> 4);
    DataOut[y++] = DataIn[i] & 0x0F;
  }
  return y;
}



