



var UInt4 = function (value) {
	return (value & 0xF);
};

var Int4 = function (value) {
	var ref = UInt4(value);
	return (ref > 0x7) ? ref - 0x10 : ref;
};

var UInt8 = function (value) {
	return (value & 0xFF);
};

var Int8 = function (value) {
	var ref = UInt8(value);
	return (ref > 0x7F) ? ref - 0x100 : ref;
};

var UInt16 = function (value) {
	return (value & 0xFFFF);
};

var Int16 = function (value) {
	var ref = UInt16(value);
	return (ref > 0x7FFF) ? ref - 0x10000 : ref;
};

function toHexString(byteArray,separetor) 
{
    return Array.from(byteArray, function(byte) {
      return ('0' + (byte & 0xFF).toString(16)).slice(-2);
    }).join(separetor)
} 

function StringHexToByteArray(string,separetor) 
{
	//rimuovo i separatori
	let hexString = string.split(separetor).join('');

    if (hexString.length % 2 !== 0) {
        throw "Must have an even number of hex digits to convert to bytes";
    }/* w w w.  jav  a2 s .  c o  m*/
    var numBytes = hexString.length / 2;
    var byteArray = new Uint8Array(numBytes);
    for (var i=0; i<numBytes; i++) {
        byteArray[i] = parseInt(hexString.substr(i*2, 2), 16);
    }
    return byteArray;
}

function BytesToUint16(byteH,byteL)
{
    //var sign = byteH & (1 << 7);
    var x = (((byteH & 0xFF) << 8) | (byteL & 0xFF));
    /*if (sign) {
       result = 0xFFFF0000 | x;  // fill in most significant bits with 1's
    }
    return result;*/
    return x;
}

//connenct to specific client
function ConnectDevice(mac, nAttempts)
{
    console.log("mac", mac);

    document.getElementById("scanLoop").checked = false;    //elimino il loop dello scan se attivo

    let macArr=StringHexToByteArray(mac,":");
    macArr = macArr.reverse();
    //il mac arriva con flag
    /*let byteArray = new Uint8Array(macArr.length + 1);
    byteArray.set(0);
    byteArray.set(macArr,1);  //aggiunto il byte di flag che è sempre a 0
    console.log("mac arr", byteArray);*/
    let mecEnc = []; 
    SysexDataCode(macArr/*byteArray*/,mecEnc)
    console.log("mecEnc",mecEnc)
    let data =[];
    data[0] = SyseExCMD.SYSEX_CMD_Connect_specific_Client;
    data[1] = nAttempts;  //numero tentativi
    data = data.concat(mecEnc);
    console.log("data", toHexString(data," "));
    //delete old rows
    //ListDeleteAllChildRaws("deviceTables","tfoot");
    MakeMsg(data)
}

function DisconnectDevice(mac,handler)
{
    console.log("mac", mac);

    let macArr=StringHexToByteArray(mac,":");
    macArr = macArr.reverse();
    let byteArray = new Uint8Array(macArr.length + 1);
    byteArray.set(0);
    byteArray.set(macArr,1);  //aggiunto il byte di flag che è sempre a 0
    console.log("mac arr", byteArray);
    let mecEnc = []; 
    SysexDataCode(byteArray,mecEnc)
    console.log("mecEnc",mecEnc)
    let data =[];
    data[0] = SyseExCMD.SYSEX_CMD_Disconnect_specific_Client;
    data[1] = handler;  //connection handle
    data = data.concat(mecEnc);
    console.log("data", toHexString(data," "));
    //delete old rows
    //ListDeleteAllChildRaws("deviceTables","tfoot");
    MakeMsg(data)
}

function DeleteDeviceInList(listTableID,subListTableID,mac)
{

    let indexRow = ListFindeElement(listTableID,subListTableID,1,mac);
    if(indexRow >= 0) //se in lista lo tolgo
      ListDeleteChildRaw(listTableID,subListTableID,indexRow);

}

var timerAnim = null;  //use for secure timer animation

function ScanAnimationStart()
{
    document.getElementById("scanAnim").style.visibility= "visible" ;
    //timer di sicurezza che termin animazione
    //let count = 60;
    if(timerAnim)
        clearTimeout(timerAnim);
    console.log("Time's up! -1", timerAnim);

    timerAnim = setTimeout(function() 
    {
        // count--;
        // console.log(count);
        // if (count <= 0) {
        console.log("Time's up 0!", timerAnim);
        clearTimeout(timerAnim);
        console.log("Time's up!", timerAnim);
        document.getElementById("scanAnim").style.visibility= "hidden" ;
        //}
    }, 15000);

    console.log("Time's up! 2", timerAnim)

}

function ScanAnimationStop()
{
    clearTimeout(timerAnim);
    document.getElementById("scanAnim").style.visibility= "hidden";

}


