

function ListaAddRaw(listTableID,subListTableID,handler,name,mac,rssi,flags)
{

  var tableRef = document.getElementById(listTableID).getElementsByTagName(subListTableID)[0];

  // Insert a row in the table at row index 0
  var newRow   = tableRef.insertRow(tableRef.rows.length);

  // Insert a cell in the row at index 0
  var nameCell  = newRow.insertCell(0);
  var macCell  = newRow.insertCell(1);
  var rssiCell  = newRow.insertCell(2);
  var midiChCell  = newRow.insertCell(3);
  var conCell  = newRow.insertCell(4);

  // Append a text node to the cell
  var newText  = document.createTextNode(name);
  nameCell.appendChild(newText);
  
  var newText1  = document.createTextNode(mac);
  macCell.appendChild(newText1);

  var newText2;
  if(rssi !== undefined)
  {
    newText2  = document.createTextNode(rssi);
  }
  else
  {
    newText2  = document.createTextNode("");
  }
    rssiCell.appendChild(newText2);
  

  var inputConn  = document.createElement("INPUT");
  if(handler < 0 )  //lista di scan
  {
    inputConn.setAttribute("type", "button");
    inputConn.setAttribute("value", "Connect");
    inputConn.setAttribute("name", mac+flags);  //salvo il mac e flags nel name
    inputConn.addEventListener("click", function(){/*MakeMsg(SyseExCMD.SYSEX_CMD_STOP_SCAN);*/ConnectDevice(this.name)});  //stop scan e connessione ... ma se il dongle è in scan una comnnessione equivale ad uno stop da provare
  }
  else// device connected
  {
    inputConn.setAttribute("type", "button");
    inputConn.setAttribute("value", "Disconnect");
    inputConn.setAttribute("name", mac);  //salvo il mac nel name
    inputConn.setAttribute("id", handler);  //salvo handle nell id
    inputConn.addEventListener("click", function(){DisconnectDevice(this.name,this.id)});
    var newText3  = document.createTextNode(handler+1);
    midiChCell.appendChild(newText3); //midi channel
  }

  conCell.appendChild(inputConn);

  console.log("tableRef.rows.length " , tableRef.rows.length)
}


function ListaUpdateRaw(listTableID,subListTableID,rawIndex,cellIndex,data)
{
  console.log(rawIndex,cellIndex,data)
  var tableRef = document.getElementById(listTableID).getElementsByTagName(subListTableID)[0];
  tableRef.rows[rawIndex].cells[cellIndex].innerHTML = data;

}
//elimina tutte le righe di una tabella data
function ListDeleteAllChildRaws(listTableID,subListTableID)
{
  var table = document.getElementById(listTableID).getElementsByTagName(subListTableID)[0];
  console.log("table.rows.length " , table.rows.length)

  while(table.rows.length > 0)
  {
    table.deleteRow(0);
  }

}
//trova la riga con l'elemento indicato
function ListFindeElement(listTableID,subListTableID,fieldNum,elmt)
{
  var table = document.getElementById(listTableID).getElementsByTagName(subListTableID)[0];
  console.log("table.rows.length " , table.rows.length)

  for ( var i = 0; i < table.rows.length; i++ ) 
  {
    var tr = table.rows[i];
    var cll = tr.cells[fieldNum];                                                              
    if(cll.innerText.indexOf(elmt) != -1) 
    {
        console.log("riga", i);
        return i;
    }
  }
  return -1;
}
//cancella riga specifica
function ListDeleteChildRaw(listTableID,subListTableID,indexRow)
{
  var table = document.getElementById(listTableID).getElementsByTagName(subListTableID)[0];
  console.log("table.rows.length %d, indexRow %d" , table.rows.length,indexRow)
  if(indexRow<table.rows.length)
    table.deleteRow(indexRow);
}

//calcello le righe indicate come false in indexsList
function ListDeleteChildsRaw(listTableID,subListTableID,indexsList)
{
  var table = document.getElementById(listTableID).getElementsByTagName(subListTableID)[0];
  console.log("table.rows.length " , table.rows.length)

  for ( var i = table.rows.length; i >=0 ; i-- ) 
  {
    if(indexsList[i] == false)
      table.deleteRow(i);
  }

}
function ListGetLen(listTableID,subListTableID)
{
  var table = document.getElementById(listTableID).getElementsByTagName(subListTableID)[0];
  return table.rows.length;
}


